/*
Program Name : DBF2WKS()
Author       : Andi Jahja
WWW          : http://www.geocities.com/~andijahja/index.html
Email        : andijahj@link.net.id
Purpose      : Translate dBase III File into Lotus 1-2-3 Format
Description  : Public Domain
Compile      : Clipper DBF2WKS /N /M /W /A /P
Linking      : RTLINK FI DBF2WKS,CFLOAT
Syntax       : DBF2WKS [dbfFileName LotusOutPutFileName]
*/
#include "BOX.CH"
*******************************************************************************
FUNCTION _123( cInput, cOutput )
*******************************************************************************
Local nRec, nCount := 0
Local nChoice
Local aStruct
Local x
Local getlist := {}
Local wkfile
Local _123Handle

If PCount() <> 2
   cInput  := space(12)
   cOutput := space(12)
   scroll()
   @ 10,10 say "Name of file to translate :" get cInput
   @ 11,10 say "Name of output file       :" get cOutPut
   read
   if lastkey() == 27
      __Quit()
   endif
endif

cInput := Alltrim( cInput )
if !File( cInput )
   Scroll()
   Alert('File not found')
   Scroll()
   __Quit()
endif

WkFile := Alltrim( cOutput )
If At(".", cOutPut ) == 0
   wkfile := cOutput + ".WK1"
Endif

SetCursor(0)

if file( wkfile ) .and. Eval( {|| Scroll(), ( nChoice := Alert('File '+wkfile + ' already exists. Overwrite ?',{ "Yes","No" } ) ) } ) <> 1
   __Quit()
endif
DbUseArea( .T.,,cInput,"DBF_FILE",.T.)
aStruct := Dbf_File->(DbStruct())
_123Handle := lopen( wkfile )
nRec := Dbf_File->(LastRec())
For x := 1 to Len( aStruct )
   do case
   case aStruct[x][2] == "D"
      FWrite( _123Handle,chr(8)+chr(0)+chr(3)+chr(0)+lotwrd(x-1)+chr(9))
   case aStruct[x][2] == "L"
      FWrite( _123Handle,chr(8)+chr(0)+chr(3)+chr(0)+lotwrd(x-1)+chr(2))
   case aStruct[x][2] == "C"
      FWrite( _123Handle,chr(8)+chr(0)+chr(3)+chr(0)+lotwrd(x-1)+chr( aStruct[x][3] ) )
   case aStruct[x][2] == "N"
      if aStruct[x][4] == 0
         FWrite( _123Handle,chr(8)+chr(0)+chr(3)+chr(0)+lotwrd(x-1)+chr( int( ( aStruct[x][3] + 2 ) * 4  / 3 ) ) )
      else
         FWrite( _123Handle,chr(8)+chr(0)+chr(3)+chr(0)+lotwrd(x-1)+chr( aStruct[x][3] ) )
      endif
   endcase
   lput( _123Handle, aStruct[x][1], x-1, 0 )
next	

Scroll()
DispBox(11,10,13,70,B_SINGLE+" ","B+/N")
SetPos( 11,12 )
DispOut(" Translation Progress ","GR+/N")
While !Dbf_File->(Eof()) .and. inkey() <>27
   SetPos( 12, 11 )
   DispOut( Repl( Chr(219), (++nCount/nRec)*59), "W+/N" )
   for x := 1 to Dbf_File->(fcount())
      lput( _123Handle, Dbf_File->(FieldGet(x)), x-1, Dbf_File->(recno()) )
   next
   Dbf_File->(DbSkip(1))
enddo

lclose(_123Handle)

Scroll()
Alert("File "+wkfile+" created.",,"W+/B")

return nil

*******************************************************************************
FUNCTION lopen( cInput )
*******************************************************************************
Local handle := fcreate( cInput, 0 )
If handle <>-1
   FWrite(handle,chr(0)+chr(0)+chr(2)+chr(0)+chr(6)+chr(4))
Endif
Return handle

*******************************************************************************
FUNCTION lput( handle,val,col,row )
*******************************************************************************
Local mstr, decs

do case
   case ValType( val ) == "C"
      mstr := chr(15)+chr(0)+lotwrd(len(val)+7)+chr(255)+lotwrd(col)+lotwrd(row)+"'"+val+chr(0)
   case ValType( val ) == "D"
      mstr := chr(14)+chr(0)+chr(13)+chr(0)+chr(249)+lotwrd(col)+lotwrd(row)+cfloat(val-ctod('01/01/00')+2)
   case ValType( val ) == "N"
      decs := getdecs(val)
      if decs <>0
         mstr := chr(14)+chr(0)+chr(13)+chr(0)+chr(128+decs)+lotwrd(col)+lotwrd(row)+cfloat(val)
      else
         mstr := chr(14)+chr(0)+chr(13)+chr(0)+chr(192)+lotwrd(col)+lotwrd(row)+cfloat(val)
      endif
   case ValType( val ) == "L"
      mstr := chr(15)+chr(0)+chr(8)+chr(0)+chr(255)+lotwrd(col)+lotwrd(row)+"'"+if(val,"Y","N")+chr(0)
endcase
return FWrite( handle, mstr )

*******************************************************************************
FUNCTION lclose( handle )
*******************************************************************************
FWrite( handle,chr(01)+chr(0)+chr(0)+chr(0) )
fclose( handle )
return .t.

************************************************************************************
FUNCTION lotwrd( mvalue )
*******************************************************************************
return chr( mvalue%256 ) + chr(int(mvalue/256) )

*******************************************************************************
FUNCTION getdecs( mnum )
*******************************************************************************
Local smnum := str(mnum)
Local at    := at('.',smnum)
if at == 0
   return 0
endif
return len(smnum)-at
